//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_color3 PaleVioletRed
#property indicator_width3 2
#property indicator_level1 0

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    FastEma         = 12;
extern int    SlowEma         = 26;
extern int    SignalEma       =  9;
extern int    Price           = PRICE_CLOSE;
extern bool   Interpolate     = true;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double upBuffer[];
double dnBuffer[];
double miBuffer[];
double trend1[];
double trend2[];
double trend3[];
string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,upBuffer);
   SetIndexBuffer(1,dnBuffer);
   SetIndexBuffer(2,miBuffer);
   SetIndexBuffer(3,trend1);
   SetIndexBuffer(4,trend2);
   SetIndexBuffer(5,trend3);
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="CalculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame)+" ema levels - MACD ("+FastEma+","+SlowEma+","+SignalEma+")");
   return(0);
}
int deinit() {}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,i,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { upBuffer[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      double alpha = 2.0 / (1.0 + SignalEma);
      for(i=limit; i>=0; i--)
      {
         miBuffer[i] = iMACD(NULL,0,FastEma,SlowEma,1,Price,MODE_MAIN,i);
         upBuffer[i] = upBuffer[i+1];
         dnBuffer[i] = dnBuffer[i+1];
         trend1[i]   = trend1[i+1];
         trend2[i]   = trend2[i+1];
         trend3[i]   = trend3[i+1];
         
            if (miBuffer[i]>0) { upBuffer[i] = upBuffer[i+1]+alpha*(miBuffer[i]-upBuffer[i+1]); trend1[i] =  1; }
            if (miBuffer[i]<0) { dnBuffer[i] = dnBuffer[i+1]+alpha*(miBuffer[i]-dnBuffer[i+1]); trend1[i] = -1; }
            if (miBuffer[i]>upBuffer[i]) trend2[i] =  1;
            if (miBuffer[i]<upBuffer[i]) trend2[i] = -1;
            if (miBuffer[i]>dnBuffer[i]) trend3[i] =  1;
            if (miBuffer[i]<dnBuffer[i]) trend3[i] = -1;
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         upBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastEma,SlowEma,SignalEma,Price,0,y);
         dnBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastEma,SlowEma,SignalEma,Price,1,y);
         miBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastEma,SlowEma,SignalEma,Price,2,y);
         trend1[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastEma,SlowEma,SignalEma,Price,3,y);
         trend2[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastEma,SlowEma,SignalEma,Price,4,y);
         trend3[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastEma,SlowEma,SignalEma,Price,5,y);

         //
         //
         //
         //
         //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               miBuffer[i+k] = miBuffer[i] + (miBuffer[i+n]-miBuffer[i])*k/n;
               upBuffer[i+k] = upBuffer[i] + (upBuffer[i+n]-upBuffer[i])*k/n;
               dnBuffer[i+k] = dnBuffer[i] + (dnBuffer[i+n]-dnBuffer[i])*k/n;
            }
   }
   
   //
   //
   //
   //
   //
      
   manageAlerts();
   return(0);         
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      static datetime alertTime1 = 0;
      static string   alertMess1 = "";
         if (trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] == 1) doAlert(alertTime1,alertMess1,whichBar,0," zero line","up");
            if (trend1[whichBar] ==-1) doAlert(alertTime1,alertMess1,whichBar,0," zero line","down");
         }         
      static datetime alertTime2 = 0;
      static string   alertMess2 = "";
         if (trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] == 1) doAlert(alertTime2,alertMess2,whichBar,upBuffer[whichBar],"upper level","up");
            if (trend2[whichBar] ==-1) doAlert(alertTime2,alertMess2,whichBar,upBuffer[whichBar],"upper level","down");
         }         
      static datetime alertTime3 = 0;
      static string   alertMess3 = "";
         if (trend3[whichBar] != trend3[whichBar+1])
         {
            if (trend3[whichBar] == 1) doAlert(alertTime3,alertMess3,whichBar,dnBuffer[whichBar],"lower level","up");
            if (trend3[whichBar] ==-1) doAlert(alertTime3,alertMess3,whichBar,dnBuffer[whichBar],"lower level","down");
         }         
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, double level, string what, string doWhat)
{
   string message;
   string add;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];
          
          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," EMA levels MACD crossed "+what+" "+DoubleToStr(level,4)+" ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"EMA levels MACD "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}